class Project < ActiveRecord::Base
  has_many :runs
  validates :name, presence: true, uniqueness: true

  def failing_runs
    failing_runs = 0
    runs.each do | run |
      failing_runs += 1 if run.fails.count > 0
    end
    failing_runs
  end

  def top_fail
    all_fails = []
    runs.each do |run|
      run.fails.each do |fail|
        all_fails << fail.line
      end
    end
    freq = all_fails.inject(Hash.new(0)) { |hash, value| hash[value] += 1; hash }
    all_fails.sort_by { |v| freq[v] }.last
  end

  def forecast
    case failing_runs
    when 0
      "sun"
    when 1..3
      "changeable"
    when 4..6
      "cloud"
    when 7..9
      "rain"
    when 10
      "storm"
    end
  end
end
